# (c) 2010 by Ralf Ertzinger <ralf@camperquake.de>
# licensed under GNU GPL v2
#
# Grabber for twitter

package TwitterGrabber;

use GrabberBase;
@ISA = qw(GrabberBase);

use LWP::Simple qw(!get);
use Data::Dumper;
use XML::Simple;
use HTML::Entities qw(decode_entities);
use Encode;

use strict;

sub new {
    my $class = shift;
    my $self = $class->SUPER::new();

    $self->{'NAME'} = 'twitter.com';
    $self->{'PATTERNS'} = ['(http://twitter.com/(?:\#\!/)?[^/]+/status(?:es)?/(\d+))'];

    bless($self, $class);
    $self->_prepare_parameters();

    return $self;
}

sub _parse {
    my $self = shift;
    my $url = shift;
    my $pattern = shift;
    my $content;
    my $metadata = {};
    my $p = XML::Simple->new();
    my $t;

    $url =~ m|$pattern|;
    $url = $1;

    $metadata->{'URL'} = $url;
    $metadata->{'ID'} = $2;
    $metadata->{'TYPE'} = 'quote';
    $metadata->{'SOURCE'} = $self->{'NAME'};
    $metadata->{'CONTENT'} = undef;

    # Get the XML file containing the quote
    unless(defined($content = LWP::Simple::get(sprintf('http://api.twitter.com/1/statuses/show/%s.xml', $2)))) {
        $self->error('Could not download quote');
        return undef;
    }

    unless(defined($t = $p->XMLin($content))) {
        $self->error('Could not parse XML metadata');
        return undef;
    }

    $metadata->{'CONTENT'} = decode_entities($t->{'text'});
    $metadata->{'ID'} = $t->{'user'}->{'screen_name'} . '/' . $metadata->{'ID'};

    unless(defined($metadata->{'CONTENT'})) {
        $self->error('Could not extract quote content');
        return undef;
    }

    return $metadata;
}

1;
